%define	oname	truecrypt
%define	name	realcrypt
%define	version	4.3
%define	rel	1
%define	release	%mkrel %{rel}

Summary:	System for establishing and maintaining on-the-fly-encrypted volumes
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	Trucrypt license 2.0
Group:		System/Kernel
Source0:	http://www.truecrypt.org/downloads/%{oname}-%{version}-source-code.tar.gz
Patch0:		realcrypt-4.3-kernel-module-rebranding.patch
Patch1:		realcrypt-4.3-tools-rebranding.patch
Patch2:		realcrypt-4.3-optflags.patch
URL:		http://wiki.mandriva.com/en/RealCrypt
Provides:	%{oname} = %{version}-%{release}
Obsoletes:	%{oname}
Requires:	dkms-%{name} = %{version}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
RealCrypt is a software system for establishing and maintaining an
on-the-fly-encrypted volume (data storage device). On-the-fly encryption
means that data are automatically encrypted or decrypted right before
they are loaded or saved, without any user intervention. No data stored
on an encrypted volume can be read (decrypted) without using the correct
password or correct encryption key. Until decrypted, a RealCrypt volume
appears to be nothing more than a series of random numbers. Entire file
system is encrypted (i.e., file names, folder names, contents of every
file, and free space). RealCrypt never writes decrypted data to any
storage device (it only temporarily writes data being decrypted to RAM).

Based on TrueCrypt, freely available at http://www.truecrypt.org/.

RealCrypt is mainly just a rebrand to allow for modifications to take place,
functionality remains all the same.

%package -n	dkms-%{name}
Summary:	Linux kernel module for RealCrypt
Group:		System/Kernel
Requires(post,preun):	dkms
Requires:	dkms
Provides:	dkms-%{oname} = %{version}-%{release}
Obsoletes:	dkms-%{oname}

%description -n	dkms-%{name}
Kernel module for RealCrypt.

Based on TrueCrypt, freely available at http://www.truecrypt.org/.

%prep
%setup -q -n %{oname}-%{version}-source-code
%patch0 -p1 -b .module_rebrand
%patch1 -p1 -b .tools_rebrand
%patch2 -p1 -b .optflags

%build
cd ./Linux/Cli
%make OPTFLAGS="%{optflags}"

%install
rm -rf %{buildroot}
install -m755 ./Linux/Cli/%{oname} -D %{buildroot}%{_sbindir}/%{name}
install -m644 ./Linux/Cli/Man/%{oname}.1 -D %{buildroot}%{_mandir}/man1/%{name}.1

# symlink for compatibility with scripts, frontends etc. for truecrypt
ln -s %{name} %{buildroot}%{_sbindir}/%{oname}

######################## DKMS PART ########################
install -d %{buildroot}/usr/src/%{name}-%{version}/Linux
cp -r Linux/Kernel %{buildroot}/usr/src/%{name}-%{version}/Linux
cp -r Linux/Common %{buildroot}/usr/src/%{name}-%{version}/Linux
install -d %{buildroot}/usr/src/%{name}-%{version}/Common
cp Common/*.[ch] %{buildroot}/usr/src/%{name}-%{version}/Common
install -d %{buildroot}/usr/src/%{name}-%{version}/Crypto
cp Crypto/*.[ch] %{buildroot}/usr/src/%{name}-%{version}/Crypto

cat > %{buildroot}/usr/src/%{name}-%{version}/dkms.conf <<EOF

PACKAGE_VERSION="%{version}"
PACKAGE_NAME="%{name}"

MAKE[0]="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build/Linux/Kernel ; make KERNEL_SRC=\${kernel_source_dir}"
CLEAN="cd \${dkms_tree}/\${PACKAGE_NAME}/\${PACKAGE_VERSION}/build/Linux/Kernel ; make KERNEL_SRC=\${kernel_source_dir} clean"

BUILT_MODULE_NAME[0]="\$PACKAGE_NAME"
BUILT_MODULE_LOCATION[0]="Linux/Kernel"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/\$PACKAGE_NAME"

AUTOINSTALL=yes
REMAKE_INITRD=no
POST_INSTALL="post-install"
POST_REMOVE="post-remove"
EOF

%post -n dkms-%{name}
dkms add -m %{name} -v %{version} --rpm_safe_upgrade
dkms build -m %{name} -v %{version} --rpm_safe_upgrade
dkms install -m %{name} -v %{version} --rpm_safe_upgrade

%preun -n dkms-%{name}
dkms remove -m %{name} -v %{version} --rpm_safe_upgrade --all

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc License.txt
%{_sbindir}/%{oname}
%{_sbindir}/%{name}
%{_mandir}/man1/*

%files -n dkms-%{name}
%defattr(-,root,root)
/usr/src/%{name}-%{version}


%changelog
* Fri May 04 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 4.3-1mdv2008.0
+ Revision: 22188
- forgot to rebrand Cli.h, fixed
- remove patch for kernel 2.6.20 that got included by a mistake
- Import realcrypt



* Mon Apr 30 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 4.3-1
- realcrypt rebranding to comply with license to allow for modifications
- based on Lukas' nice work with mdk adaptions:)

* Wed Feb 08 2006 Lukas Oboril <xxlucas@seznam.cz> 4.1-0.1.20060mdk
- initial build for MDV 2006
- 4.1
